From d7d9a95fd987b990e5d42b35c5eb356d602b5191 Mon Sep 17 00:00:00 2001
From: Martin Fick <mfick@codeaurora.org>
Date: Thu, 16 Feb 2012 14:18:04 -0700
Subject: [PATCH] Add WUI support for moving changes to new branches

Add an edit button for change owners next to the
destination branch in the ChangeInfo block. This
button pops up a dialog allowing owners to move
the destination branch of the change and to add a
comment explaining the move.

Change-Id: Ide1f889319da63129f94df952e1698ef509b2979
---
 .../com/google/gerrit/client/GerritResources.java  |    3 +
 .../gerrit/client/changes/ChangeConstants.java     |    7 ++
 .../client/changes/ChangeConstants.properties      |    7 ++
 .../gerrit/client/changes/ChangeInfoBlock.java     |   75 +++++++++++++++++++-
 .../com/google/gerrit/client/changes/Util.java     |    5 ++
 .../java/com/google/gerrit/client/editText.png     |  Bin 0 -> 574 bytes
 6 files changed, 95 insertions(+), 2 deletions(-)
 create mode 100644 gerrit-gwtui/src/main/java/com/google/gerrit/client/editText.png

diff --git a/gerrit-gwtui/src/main/java/com/google/gerrit/client/GerritResources.java b/gerrit-gwtui/src/main/java/com/google/gerrit/client/GerritResources.java
index b5c0900..d2a04cc 100644
--- a/gerrit-gwtui/src/main/java/com/google/gerrit/client/GerritResources.java
+++ b/gerrit-gwtui/src/main/java/com/google/gerrit/client/GerritResources.java
@@ -28,6 +28,9 @@ public interface GerritResources extends ClientBundle {
   @Source("arrowRight.gif")
   public ImageResource arrowRight();
 
+  @Source("editText.png")
+  public ImageResource edit();
+
   @Source("starOpen.gif")
   public ImageResource starOpen();
 
diff --git a/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/ChangeConstants.java b/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/ChangeConstants.java
index 70697e4..34ce990 100644
--- a/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/ChangeConstants.java
+++ b/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/ChangeConstants.java
@@ -96,6 +96,13 @@ public interface ChangeConstants extends Constants {
   String changeInfoBlockCanMergeYes();
   String changeInfoBlockCanMergeNo();
 
+  String buttonAlterBranch();
+  String buttonAlterBranchBegin();
+  String buttonAlterBranchSend();
+  String buttonAlterBranchCancel();
+  String headingAlterBranchMessage();
+  String alterBranchTitle();
+
   String includedInTableBranch();
   String includedInTableTag();
 
diff --git a/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/ChangeConstants.properties b/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/ChangeConstants.properties
index c564ec2..03dea64 100644
--- a/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/ChangeConstants.properties
+++ b/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/ChangeConstants.properties
@@ -73,6 +73,13 @@ changeInfoBlockCanMerge = Can Merge
 changeInfoBlockCanMergeYes = Yes
 changeInfoBlockCanMergeNo = No
 
+buttonAlterBranch = Alter Destination
+buttonAlterBranchBegin = Alter Destination Branch
+buttonAlterBranchSend = Update Branch
+buttonAlterBranchCancel = Cancel
+headingAlterBranchMessage = Alter Destination Branch Message:
+alterBranchTitle = Code Review - Alter Destination Branch
+
 includedInTableBranch = Branch Name
 includedInTableTag = Tag Name
 
diff --git a/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/ChangeInfoBlock.java b/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/ChangeInfoBlock.java
index eb91180..3e98d2f 100644
--- a/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/ChangeInfoBlock.java
+++ b/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/ChangeInfoBlock.java
@@ -17,16 +17,26 @@ package com.google.gerrit.client.changes;
 import static com.google.gerrit.client.FormatUtil.mediumFormat;
 
 import com.google.gerrit.client.Gerrit;
+import com.google.gerrit.client.rpc.GerritCallback;
 import com.google.gerrit.client.ui.AccountDashboardLink;
 import com.google.gerrit.client.ui.BranchLink;
 import com.google.gerrit.client.ui.ChangeLink;
+import com.google.gerrit.client.ui.CommentedActionDialog;
 import com.google.gerrit.client.ui.ProjectLink;
 import com.google.gerrit.common.data.AccountInfoCache;
+import com.google.gerrit.common.data.ChangeDetail;
+import com.google.gerrit.common.data.ListBranchesResult;
 import com.google.gerrit.reviewdb.Branch;
 import com.google.gerrit.reviewdb.Change;
+import com.google.gwt.event.dom.client.ClickEvent;
+import com.google.gwt.event.dom.client.ClickHandler;
 import com.google.gwt.user.client.ui.Composite;
 import com.google.gwt.user.client.ui.FlowPanel;
 import com.google.gwt.user.client.ui.Grid;
+import com.google.gwt.user.client.ui.Image;
+import com.google.gwt.user.client.ui.InlineLabel;
+import com.google.gwt.user.client.ui.ListBox;
+import com.google.gwt.user.client.ui.Widget;
 import com.google.gwt.user.client.ui.HTMLTable.CellFormatter;
 import com.google.gwtexpui.clippy.client.CopyableLabel;
 
@@ -94,8 +104,7 @@ public class ChangeInfoBlock extends Composite {
 
     table.setWidget(R_OWNER, 1, AccountDashboardLink.link(acc, chg.getOwner()));
     table.setWidget(R_PROJECT, 1, new ProjectLink(chg.getProject(), chg.getStatus()));
-    table.setWidget(R_BRANCH, 1, new BranchLink(dst.getShortName(), chg
-        .getProject(), chg.getStatus(), dst.get(), null));
+    table.setWidget(R_BRANCH, 1, branch(chg));
     table.setWidget(R_TOPIC, 1, new BranchLink(chg.getTopic(),
         chg.getProject(), chg.getStatus(), dst.get(), chg.getTopic()));
     table.setText(R_UPLOADED, 1, mediumFormat(chg.getCreatedOn()));
@@ -117,4 +126,66 @@ public class ChangeInfoBlock extends Composite {
     fp.add(new CopyableLabel(ChangeLink.permalink(chg.getId()), false));
     table.setWidget(R_PERMALINK, 1, fp);
   }
+
+  public Widget branch(final Change chg) {
+    final Branch.NameKey dst = chg.getDest();
+
+    FlowPanel fp = new FlowPanel();
+    fp.add(new BranchLink(dst.getShortName(), chg.getProject(), chg.getStatus(),
+        dst.get(), null));
+
+    final Image edit = new Image(Gerrit.RESOURCES.edit());
+    edit.addClickHandler(new  ClickHandler() {
+      @Override
+      public void onClick(final ClickEvent event) {
+        new MoveChangeDialog(chg).center();
+      }
+    });
+    fp.add(edit);
+
+    return fp;
+  }
+
+  private class MoveChangeDialog extends CommentedActionDialog<ChangeDetail> {
+    ListBox destinations;
+    Change change;
+
+    MoveChangeDialog(Change chg) {
+      super(Util.C.alterBranchTitle(), Util.C.headingAlterBranchMessage(),
+          new ChangeDetailCache.IgnoreErrorCallback());
+      change = chg;
+
+      destinations = new ListBox();
+      panel.insert(destinations, 0);
+      panel.insert(new InlineLabel("Alter destination branch to:"), 0);
+    }
+
+    @Override
+    protected void onLoad() {
+      super.onLoad();
+      Util.DETAIL_SVC.listDestinationBranches(change.getProject(),
+        new GerritCallback<ListBranchesResult>() {
+          @Override
+          public void onSuccess(final ListBranchesResult result) {
+            if (!result.getNoRepository()) {
+              for (Branch dest : result.getBranches()) {
+                // refs/heads/master -> master
+                String ref = dest.getName().replaceFirst("^refs/heads/", "");
+                if (!ref.equals(dest.getName()) &&
+                    !dest.getNameKey().equals(change.getDest())) {
+                  destinations.addItem(dest.getShortName());
+                }
+              }
+            }
+          }
+        });
+    }
+
+    @Override
+    public void onSend() {
+      String dest = destinations.getItemText(destinations.getSelectedIndex());
+      Util.MANAGE_SVC.moveChange(change.currPatchSetId(), dest,
+        getMessageText(), createCallback());
+    }
+  }
 }
diff --git a/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/Util.java b/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/Util.java
index 3fe63ed..3387ce2 100644
--- a/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/Util.java
+++ b/gerrit-gwtui/src/main/java/com/google/gerrit/client/changes/Util.java
@@ -17,6 +17,7 @@ package com.google.gerrit.client.changes;
 import com.google.gerrit.common.data.ChangeDetailService;
 import com.google.gerrit.common.data.ChangeListService;
 import com.google.gerrit.common.data.ChangeManageService;
+import com.google.gerrit.common.data.ProjectAdminService;
 import com.google.gerrit.reviewdb.Change;
 import com.google.gwt.core.client.GWT;
 import com.google.gwtjsonrpc.client.JsonUtil;
@@ -25,6 +26,7 @@ public class Util {
   public static final ChangeConstants C = GWT.create(ChangeConstants.class);
   public static final ChangeMessages M = GWT.create(ChangeMessages.class);
   public static final ChangeResources R = GWT.create(ChangeResources.class);
+  public static final ProjectAdminService PROJECT_SVC;
 
   public static final ChangeDetailService DETAIL_SVC;
   public static final ChangeListService LIST_SVC;
@@ -39,6 +41,9 @@ public class Util {
 
     MANAGE_SVC = GWT.create(ChangeManageService.class);
     JsonUtil.bind(MANAGE_SVC, "rpc/ChangeManageService");
+
+    PROJECT_SVC = GWT.create(ProjectAdminService.class);
+    JsonUtil.bind(PROJECT_SVC, "rpc/ProjectAdminService");
   }
 
   public static String toLongString(final Change.Status status) {
diff --git a/gerrit-gwtui/src/main/java/com/google/gerrit/client/editText.png b/gerrit-gwtui/src/main/java/com/google/gerrit/client/editText.png
new file mode 100644
index 0000000000000000000000000000000000000000..188e1c12bd2de0029c75eefc6c7c4753b86b7d9b
GIT binary patch
literal 574
zcmV-E0>S->P)<h;3K|Lk000e1NJLTq000mG000mO1^@s6AM^iV00006VoOIv0RI60
z0RN!9r;`8x010qNS#tmY3ljhU3ljkVnw%H_000McNliru)d?07Hz_+(0!RP=0n155
zK~y-)rISr)6G0Tme>2^qNERY3;<4Z<pjayb4}ukhc<e>cwkNNp7Zp5;AjKf{B7T6H
z7K$;wTN)8fToCQSV$+QqO#Q&sZ0iseT9M6oFhjF#YAe3W{|(Ih&u?blgZ~U+lHy(Z
zfEnP}R(g1dys47_mq#z10cH*!ci4`$5?D>W0r2hlIkux$PfFdaJ1vdV-c&$Y6<FPq
zr>qM6=z7>zUrb8|$BG>39|jmV1jOTU#EGRpi+xRHO?}@de@`-W?HM1Qj5D_ogg}SY
zdLN|}^?H57O9w%Kn@Oz|d&_(+O?3c05d+({v28n2?E5}$CdJ@bk;TUuUX_<or5r%d
z$Yf*ouLS1gfpmeze1^HV3RTMSbN@xopS>^(h)oH!))dmc3|x7NH+_f7=kKWb2fXhZ
zrnAjAMhLXlWV2a*$wSOL4(~qIS$aJMy=iu>tN_|Hp>9hMh9SE@rg`+GoBO#O-SQ<n
z`)-j;CUIStH<bm9i(F4otyb|okCDj+M>{L5?nn?G7$uQNU|ANHWktGp13@enLu*Z~
zRzquzloG8qLI{Kqt=k(B1Emy><7_&0#$<gMgNd8Bub=vdDV{LNZ(5z`n0X2O5&!@I
M07*qoM6N<$g3L7U<p2Nx

literal 0
HcmV?d00001

-- 
1.7.8

